/**
 * Copyright (C) 2010-2012 Andrei Pozolotin <Andrei.Pozolotin@gmail.com>
 *
 * All rights reserved. Licensed under the OSI BSD License.
 *
 * http://www.opensource.org/licenses/bsd-license.php
 */
package com.carrotgarden.util.values.provider;

import com.carrotgarden.util.anno.NotMutable;
import com.carrotgarden.util.values.api.PriceValue;

// 8 bytes on 32 bit JVM
@NotMutable
final class NulPrice extends BasePrice {

	@Override
	public long mantissa() {
		return 0;
	}

	@Override
	public int exponent() {
		return 0;
	}

	@Override
	protected PriceValue result(long mantissa, int exponent) {
		return ValueBuilder.newPrice(mantissa, exponent);
	}

}
